package enseirb.myinpulse.service.database.old_controllers_to_convert_to_services;

import enseirb.myinpulse.model.Administrator;
import enseirb.myinpulse.repository.AdministratorRepository;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

@RestController
public class AdministratorController {

    @Autowired AdministratorRepository administratorRepository;

    @GetMapping("/Administrator")
    @ResponseBody
    public Iterable<Administrator> allAdministrators() {
        return this.administratorRepository.findAll();
    }

    @GetMapping("/Administrator/{id}")
    public Administrator getAdministratorById(@PathVariable Long id) {
        Optional<Administrator> administrator = this.administratorRepository.findById(id);
        if (administrator.isEmpty()) {
            throw new ResponseStatusException(
                    HttpStatus.NOT_FOUND, "Cet administrateur n'existe pas");
        }
        return administrator.get();
    }

    @PostMapping("/Administrateurs")
    public Administrator addAdministrator(@RequestBody Administrator administrator) {
        return this.administratorRepository.save(administrator);
    }
}
